<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.menu');

class plgPaymentPayrobokassa extends JPlugin
{
	var $_db = null;

	function plgPaymentPayrobokassa(& $subject, $config)
	{
		$this->_db = JFactory::getDBO();
		parent::__construct($subject, $config);
	}

	function onReceivePayment(&$post)
	{
		global $mainframe;
		if ($mainframe->isAdmin())
			return;
		if ($post['processor'] != 'payrobokassa')
			return 0;
		
		$default = $this->params;
		$params = new JRegistry($post['params']);
		
		$out['sid'] = $post["Shp_item"];
		$inv_id = $post['InvId'];
		$out['gateway'] = $post['processor'];
		$out['user_id'] = $user_id = $post["Shp_user"];
		$out['gateway_id'] = $gateway_id = $post['InvId'];
		$out['price'] = $post["OutSum"];
		$out_summ = $post["OutSum"];
		if (isset($post['pay']))
			$out['pay'] = $post['pay'];
		$out['email'] = $post['Email'];
		$crc = $post["SignatureValue"];
		
		if (JRequest::getVar('status') != 'notify')
		{
			$mrh_pass2 = $params->get('payrobokassa_psw1', $default->get('payrobokassa_psw1'));
		}
		else
		{
			$mrh_pass2 = $params->get('payrobokassa_psw2', $default->get('payrobokassa_psw2'));
		}
		
		$crc = strtoupper($crc);
	
		$my_crc = strtoupper(md5("$out_summ:$inv_id:$mrh_pass2:Shp_item={$post['Shp_item']}:Shp_user={$post['Shp_user']}"));
		
		if ($params->get('payrobokassa_errorlog', $default->get('payrobokassa_errorlog')))
			error_log("[Start CRC check]:  post $crc = $my_crc gen\n". print_r($post, true) . "\n\n", 3, JPATH_ROOT . DS . 'plugins' . DS . 'payment' . DS . 'rk_log.txt');
			
		// check signature
		if ($my_crc != $crc)
		{
			if ($params->get('payrobokassa_errorlog', $default->get('payrobokassa_errorlog')))
			error_log("[CRC check failed]\n\n", 3, JPATH_ROOT . DS . 'plugins' . DS . 'payment' . DS . 'rk_log.txt');
			
			$out['pay'] = 'fail';
			$out['msg'] = FAILED_MSG;			
		}
		else
		{
			if (JRequest::getVar('status') != 'notify')
			{
				$out['pay'] = $post['status'];//'success';
			}
			elseif (JRequest::getVar('curl') != 'ok')
			{
				$url = JURI::root() . "/index.php?curl=ok&";
				$par = array();
				foreach($post as $key => $value)
					$par[] = $key . "=" . $value;
				$par = implode('&', $par);
				$url .= $par;
				$ch = curl_init($url);
				curl_exec($ch);
				curl_close($ch);
				die("OK" . $post['InvId']);
			}
			else
			{
				$user = JFactory::getUser($user_id);
				$url = $params->get('payrobokassa_external', $default->get('payrobokassa_external'));
				$url = str_replace(array('{email}', '{id}'), array($user->email, $out['sid']), $url);
				$ch = curl_init($url);
				curl_exec($ch);
				curl_close($ch);
				
				$out['pay'] = 'success';
			}
		
		}

		// save order info to file
		if ($params->get('payrobokassa_errorlog', $default->get('payrobokassa_errorlog')))
			error_log("[Start get post after check]:  " . print_r($post, true) . "\n\n", 3, JPATH_ROOT . DS . 'plugins' . DS . 'payment' . DS . 'rk_log.txt');
		
		return $out;
	}

	function onSendPayment(&$post)
	{
		if ($post['processor'] != 'payrobokassa')
			return false;
		
		$user = JFactory::getUser();
		
		$default = $this->params;
		$params = new JRegistry($post['params']);
		
		$mrh_login = $params->get('payrobokassa_login', $default->get('payrobokassa_login'));
		$mrh_pass1 = $params->get('payrobokassa_psw1', $default->get('payrobokassa_psw1'));
		// number of order
		$inv_id = time();
		
		// order description
		$inv_desc = $post['order_title'];
		
		// sum of order
		$out_summ = @floatval($post['order_amount']);
		
	
		// default payment e-currency
		$in_curr = $params->get('payrobokassa_curr', $default->get('payrobokassa_curr'));
		
		// language
		$culture = $params->get('payrobokassa_lang', $default->get('payrobokassa_lang'));
		
		// generate signature
		$crc = md5("$mrh_login:$out_summ:$inv_id:$mrh_pass1:Shp_item={$post['order_id']}:Shp_user={$user->id}");
		
		$param = array();
		$param['MrchLogin'] = $mrh_login;
		$param['OutSum'] = $out_summ;
		$param['InvId'] = $inv_id;
		$param['Desc'] = $inv_desc;
		$param['SignatureValue'] = $crc;
		$param['Shp_item'] = $post['order_id'];
		$param['Shp_user'] = $user->id;
		$param['IncCurrLabel'] = $in_curr;
		$param['Culture'] = $culture;
		$param['Email'] = isset($post['email']) ? $post['email'] : $user->email;
		
		if ($params->get('payrobokassa_errorlog', $default->get('payrobokassa_errorlog')))
			error_log("[Start send crc]:  " . $crc . "\n\n", 3, JPATH_ROOT . DS . 'plugins' . DS . 'payment' . DS . 'rk_log.txt');
		
		//$url = "http://test.robokassa.ru/Index.aspx";
		$url = "https://merchant.roboxchange.com/Index.aspx";
		$txt = '';
		$txt .= '<dl id="system-message">
					<dt class="notice">Message</dt>
					<dd class="notice">
						<ul>
							<li>
							' . JText::_("This page will redirect you to the payment gateway in") . ' <span id="countDown">5 ' . JText::_('seconds') . '</span>
							</li>
						</ul>
					</dd>
	  			</dl>';
		$txt .= '<form action="' . $url . '" method="post" name="formPayBill">';
		foreach($param as $name => $val)
		{
			$txt .= '<input type="hidden" name="' . $name . '" value="' . $val . '">';
		}
		$txt .= '</form>';
		
		$txt .= '<script type="text/javascript">
				countdown(5);
				function countdown(i)
				{				
					document.getElementById("countDown").innerHTML = i + (i == 1 ? " second": " seconds");
					i = i - 1;
					if(i >= 0)
					setTimeout("countdown(" + i + ")", 1000);
					else
					document.formPayBill.submit();
				}
				</script>
				<noscript>
				<p>' . JText::_('If you are not redirected automatically please click the button Send') . '
				<input type="submit" value="' . JText::_('Send') . '" class="button">
				</p>
				</noscript>';
		/*$txt .= '<script type="text/javascript">
					document.formPayBill.submit();
			</script>';*/
		echo $txt;
	
	}

	function onCheckParams($params)
	{
		$db = JFactory::getDBO();
		$sql = "SELECT name FROM #__plugins WHERE folder = 'payment' AND element = 'payrobokassa'";
		$db->setQuery($sql);
		$title = $db->loadResult();
		if ($params->get('payrobokassa_login') == '')
			JError::raiseNotice(100, $title . ': ' . JText::_('Merchant login is not set'));
		if ($params->get('payrobokassa_psw1') == '')
			JError::raiseNotice(100, $title . ': ' . JText::_('Merchant password #1 is not set'));
		if ($params->get('payrobokassa_psw2') == '')
			JError::raiseNotice(100, $title . ': ' . JText::_('Merchant password #2 is not set'));
	}
}

function RKArray2Url($param)
{
	foreach($param as $k => $v)
	{
		$out[] = "$k=$v";
	}
	return implode('&', $out);
}

?>